=== modified file 'src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java'
--- src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java	2021-06-10 11:50:04 +0000
+++ src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java	2021-06-18 18:47:18 +0000
@@ -7629,292 +7794,6 @@
    }
 
    /**
-    * Draws treeview nodes.
-    *
-    * @param   gd
-    *          GUI driver.
-    * @param   gc
-    *          Color resolver.
-    * @param   tree
-    *          Tree widget, the owner of the tree body.
-    * @param   nodes
-    *          Nodes to draw.
-    * @param   currentNode
-    *          Current node.
-    * @param   valueIndex
-    *          The index of the value to be displayed. For TREEVIEW widget this is always 0.
-    * @param   rowIdx
-    *          Row index.
-    * @param   font
-    *          Text font.
-    * @param   rowHeight
-    *          Row height.
-    * @param   rowWidth
-    *          Row width.
-    * @param   level
-    *          Tree level.
-    * @param   enabled
-    *          Widget enabled state.
-    * @param   selectionBack
-    *          Selection back color.
-    * @param   selectionFore
-    *          Selection foreground color.
-    * @param   disabledFore
-    *          Disabled widget foreground color.
-    */
-   private <N extends TreeNodeEntry> int drawTreeViewNodes(final GuiDriver gd,
-                                                           final GuiColorResolver gc,
-                                                           final TreeGuiImpl tree,
-                                                           final List<TreeGuiImpl.TreeNode<N>> nodes,
-                                                           final TreeGuiImpl.TreeNode<N> currentNode,
-                                                           final int valueIndex,
-                                                           final int rowIdx,
-                                                           final GuiFontResolver.FontCache font,
-                                                           final int rowHeight,
-                                                           final int rowWidth,
-                                                           final int level,
-                                                           final boolean enabled,
-                                                           final ColorRgb selectionBack,
-                                                           final ColorRgb selectionFore,
-                                                           final ColorRgb disabledFore)
-   {
-      int row = rowIdx;
-      final int nodeCount = nodes.size();
-      int parentRowIdx = row - 1;
-      int prevExpIcoRowIdx = -1;
-
-      final TreeConfig c = tree.config();
-      final int imageListId = c.imageListId;
-
-      for (int i = 0; i < nodeCount; i++)
-      {
-         final TreeGuiImpl.TreeNode node = nodes.get(i);
-         final boolean showExpandIcon = c.showExpandIcon && node.value.hasChildren;
-
-         drawTreeViewNode(gd,
-                          gc,
-                          tree,
-                          node,
-                          currentNode,
-                          valueIndex,
-                          row,
-                          parentRowIdx,
-                          prevExpIcoRowIdx,
-                          font,
-                          rowHeight,
-                          rowWidth,
-                          level,
-                          enabled,
-                          i == 0,
-                          i == nodeCount - 1,
-                          showExpandIcon,
-                          selectionBack,
-                          selectionFore,
-                          disabledFore,
-                          imageListId);
-
-         if (showExpandIcon)
-         {
-            prevExpIcoRowIdx = row;
-         }
-         row++;
-
-         if (node.value.expanded && node.nodes != null)
-         {
-            row = drawTreeViewNodes(gd,
-                                       gc,
-                                       tree,
-                                       node.nodes,
-                                       currentNode,
-                                       valueIndex,
-                                       row,
-                                       font,
-                                       rowHeight,
-                                       rowWidth,
-                                       level + 1,
-                                       enabled,
-                                       selectionBack,
-                                       selectionFore,
-                                       disabledFore);
-         }
-      }
-
-      return row;
-   }
-
-   /**
-    * Draws TREELIST nodes.
-    *
-    * @param   gd
-    *          GUI driver.
-    * @param   gc
-    *          Color resolver.
-    * @param   font
-    *          Text font.
-    * @param   tree
-    *          Tree widget instance.
-    * @param   nodes
-    *          Root tree nodes to render.
-    * @param   currentNode
-    *          Selected tree node.
-    * @param   nodeIndex
-    *          Index of the first node in the supplied nodes list.
-    * @param   selectionBg
-    *          Selection tree node background color.
-    * @param   selectionFg
-    *          Selection tree node foreground color.
-    * @param   columns
-    *          Tree list columns.
-    * @param   nodeHeight
-    *          Node height in pixels.
-    */
-   private <N extends TreeNodeEntry> int drawTreeListNodes(final GuiDriver gd,
-                                                           final GuiColorResolver gc,
-                                                           final GuiFontResolver.FontCache font,
-                                                           final TreeListGuiImpl tree,
-                                                           final List<TreeGuiImpl.TreeNode<N>> nodes,
-                                                           final TreeGuiImpl.TreeNode<N> currentNode,
-                                                           final int nodeIndex,
-                                                           final ColorRgb selectionBg,
-                                                           final ColorRgb selectionFg,
-                                                           final List<TreeListGuiImpl.ColumnCache> columns,
-                                                           final int nodeHeight)
-   {
-      int idx = nodeIndex;
-      if (nodes != null)
-      {
-         for (final TreeGuiImpl.TreeNode node : nodes)
-         {
-            final boolean isSelected = node == currentNode;
-
-            // FIXME: the background color passed here must be affected by the node color. 
-            final ColorRgb bgColor = gc.bgColor;
-            final ColorRgb fgColor = gc.fgColor;
-            drawTreeListNode(gd, font, tree, columns, nodeHeight, idx, node,
-                     isSelected ? selectionFg : fgColor, isSelected ? selectionBg : bgColor,
-                     bgColor, isSelected);
-            idx++;
-
-            if (node.value.expanded && node.nodes != null)
-            {
-               idx = drawTreeListNodes(gd,
-                                             gc,
-                                             font,
-                                             tree,
-                                             node.nodes,
-                                             currentNode,
-                                             idx,
-                                             selectionBg,
-                                             selectionFg,
-                                             columns,
-                                             nodeHeight);
-            }
-         }
-      }
-
-      return idx;
-   }
-
-   /**
-    * Draws TREELIST node.
-    *
-    * @param   gd
-    *          GUI driver.
-    * @param   font
-    *          Text font.
-    * @param   tree
-    *          Tree widget instance.
-    * @param   columns
-    *          Tree list columns.
-    * @param   nodeHeight
-    *          Node height.
-    * @param   nodeIndex
-    *          Node index.
-    * @param   node
-    *          Tree node.
-    * @param   fgColor
-    *          Foreground color.
-    * @param   bgSelColor
-    *          Background color for selected node.
-    * @param   bgColor
-    *          Background color for regular node.
-    * @param   selected
-    *          If <code>TRUE</code> the node is selected, otherwise - not..
-    */
-   private void drawTreeListNode(final GuiDriver gd,
-                                 final GuiFontResolver.FontCache font,
-                                 final TreeListGuiImpl tree,
-                                 final List<TreeListGuiImpl.ColumnCache> columns,
-                                 final int nodeHeight,
-                                 final int nodeIndex,
-                                 final TreeGuiImpl.TreeNode node,
-                                 final ColorRgb fgColor,
-                                 final ColorRgb bgSelColor,
-                                 final ColorRgb bgColor,
-                                 final boolean selected)
-   {
-      final int nColumns = columns.size();
-      if (nColumns < 2)
-      {
-         return;
-      }
-
-      final TreeListGuiImpl.ColumnCache firstColumn = columns.get(0);
-      int xOff = firstColumn.column.width;
-      for (final TreeListGuiImpl.ColumnCache cc : columns.subList(1, nColumns))
-      {
-         final Column column = cc.column;
-         if (!column.visible)
-         {
-            continue;
-         }
-
-         final TreeListNodeEntry entry = (TreeListNodeEntry) node.value;
-         final List<Object> cellValues = entry.cellValues;
-         final int index = cc.index;
-         final Object value = index < cellValues.size() ? cellValues.get(index) : null;
-
-         final int colWidth = column.width;
-
-         final NativePoint p = new NativePoint(xOff, nodeHeight * nodeIndex);
-         final NativeDimension dim = new NativeDimension(colWidth, nodeHeight);
-         final NativeRectangle clip = AbstractWidget.clipRectangle(p, dim);
-         
-         gd.draw(p, clip, () -> {
-            final List<ColorRgb> bgColors = entry.cellBGColors;
-            ColorRgb effBgColor = null;
-            if (index < bgColors.size())
-            {
-               effBgColor = bgColors.get(index);
-            }
-
-            if (effBgColor == null)
-            {
-               final ColorRgb columnBgColor = column.bgColor;
-               effBgColor = columnBgColor != null ? columnBgColor : bgColor;
-            }
-
-            final List<ColorRgb> fgColors = entry.cellBGColors;
-            ColorRgb effFgColor = null;
-            if (index < fgColors.size())
-            {
-               effFgColor = fgColors.get(index);
-            }
-            if (effFgColor == null)
-            {
-               final ColorRgb columnFgColor = column.fgColor;
-               effFgColor = columnFgColor != null ? columnFgColor : fgColor;
-            }
-
-            drawTreeListCell(gd, font, tree, colWidth, nodeHeight, effFgColor, bgSelColor,
-                     effBgColor, value, column.align, selected, column.dataType);
-         });
-
-         xOff += colWidth;
-      }
-   }
-   
-   /**
     * Draws progress bar {@code ProgressBarGui} widget.
     *
     * @param   pb
@@ -7997,6 +7876,7 @@
     * @param   height
     *          The height of the painted widget/component.
     */
+   @SuppressWarnings("static-method")
    private void drawProgressBarBar(ProgressBarGui pb, 
                                    GuiDriver gd, 
                                    GuiColorResolver gc,

=== modified file 'src/com/goldencode/p2j/ui/client/gui/theme/Theme.java'
--- src/com/goldencode/p2j/ui/client/gui/theme/Theme.java	2020-10-24 22:32:57 +0000
+++ src/com/goldencode/p2j/ui/client/gui/theme/Theme.java	2021-06-17 17:52:42 +0000
@@ -163,7 +163,10 @@
    /**
     * Release any held resources when this {@code Theme} is removed. 
     */
-   public default void releaseResources() {};
+   public default void releaseResources()
+   {
+      // empty
+   };
    
    /**
     * Obtain an image resource specific to this {@code Theme}. The image can be cached for

=== added file 'src/com/goldencode/p2j/ui/client/model/I2DScrollable.java'
--- src/com/goldencode/p2j/ui/client/model/I2DScrollable.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/model/I2DScrollable.java	2021-06-10 20:49:41 +0000
@@ -0,0 +1,25 @@
+package com.goldencode.p2j.ui.client.model;
+
+/**
+ * Two-dimensional scrollable object. This interface defines two methods {@link #updateHScrollModel()} and
+ * {@link #updateVScrollModel()}, which should be called by application any time the horizontal/vertical
+ * scrolling models should be updated.
+ */
+public interface I2DScrollable
+extends IModelChangeListener
+{
+   /**
+    * Update the vertical scrolling model based on this object geometry and contents.
+    * 
+    * @return {@code true} if model was changed as the result of the call.
+    */
+   boolean updateVScrollModel();
+
+   /**
+    * Update the horizontal scrolling model based on this object geometry and contents.
+    * 
+    * @return {@code true} if model was changed as the result of the call.
+    */
+   boolean updateHScrollModel();
+
+}
\ No newline at end of file

=== added file 'src/com/goldencode/p2j/ui/client/model/IModelChangeListener.java'
--- src/com/goldencode/p2j/ui/client/model/IModelChangeListener.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/model/IModelChangeListener.java	2021-06-09 16:43:25 +0000
@@ -0,0 +1,16 @@
+package com.goldencode.p2j.ui.client.model;
+
+/**
+ * See {@link Model}.
+ *
+ */
+public interface IModelChangeListener
+{
+   /**
+    * This procedure is called by the model after it was changed.
+    * 
+    * @param model the model that was changed
+    */
+   void modelChanged(Model model);
+
+}

=== added file 'src/com/goldencode/p2j/ui/client/model/IntegerModel.java'
--- src/com/goldencode/p2j/ui/client/model/IntegerModel.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/model/IntegerModel.java	2021-06-09 17:08:50 +0000
@@ -0,0 +1,50 @@
+package com.goldencode.p2j.ui.client.model;
+
+/**
+ * Integer number model.
+ * 
+ */
+public final class IntegerModel extends Model
+{
+   /**
+    * The value.
+    */
+   private int value;
+
+   /**
+    * The constructor.
+    */
+   public IntegerModel(int value)
+   {
+      this.value = value;
+   }
+
+   /**
+    * Set the value.
+    * 
+    * @param index the new value
+    * 
+    * @return {@code true} if model was changed as the result of this call.
+    */
+   public boolean setValue(int index)
+   {
+      if (this.value == index)
+      {
+         return false;
+      }
+
+      this.value = index;
+      changed();
+      return true;
+   }
+
+   /**
+    * Get the value index value.
+    * 
+    * @return see above
+    */
+   public int getValue()
+   {
+      return value;
+   }
+}

=== added file 'src/com/goldencode/p2j/ui/client/model/Model.java'
--- src/com/goldencode/p2j/ui/client/model/Model.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/model/Model.java	2021-06-09 16:44:37 +0000
@@ -0,0 +1,75 @@
+/**
+ * 
+ */
+package com.goldencode.p2j.ui.client.model;
+
+import java.util.*;
+
+/**
+ *
+ */
+public abstract class Model
+{
+
+   private List<IModelChangeListener> listeners;
+
+   /**
+    * Notify model listeners.
+    */
+   public void changed()
+   {
+      // info("{0}", this);
+
+      if (listeners != null)
+      {
+         for (IModelChangeListener listener : listeners)
+         {
+            listener.modelChanged(this);
+         }
+      }
+
+   }
+
+   @SuppressWarnings("null")
+   private final List<IModelChangeListener> getListenersForUpdate()
+   {
+      if (listeners == null)
+      {
+         listeners = new ArrayList<>();
+      }
+
+      return listeners;
+   }
+
+   /**
+    * Add listener for scrolling changes.
+    * It is an error to add the same object twice.
+    * 
+    * @param listener the object that will be notified
+    */
+   public void addListener(IModelChangeListener listener)
+   {
+      final List<IModelChangeListener> l = getListenersForUpdate();
+      if (!l.contains(listener))
+      {
+         l.add(listener);
+      }
+   }
+
+   /**
+    * Remove the object from the listener list.
+    * 
+    * @param listener the object to be removed.
+    */
+   public void removeListener(IModelChangeListener listener)
+   {
+      getListenersForUpdate().remove(listener);
+   }
+
+   /**
+    * Default constructor.
+    */
+   public Model()
+   {
+   }
+}
\ No newline at end of file

=== added file 'src/com/goldencode/p2j/ui/client/model/ScrollModel.java'
--- src/com/goldencode/p2j/ui/client/model/ScrollModel.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/model/ScrollModel.java	2021-06-09 17:21:15 +0000
@@ -0,0 +1,188 @@
+package com.goldencode.p2j.ui.client.model;
+
+/**
+ * Scrollable model.
+ * 
+ * The model includes the following data:
+ * 
+ * <ul>
+ * <li>{@link #width} - the total "view width"
+ * <li>{@link #page} - the part of the width which is "visible"
+ * <li>{@link #position} - the offset of the visible part
+ * </ul>
+ * 
+ * <p>
+ * The following relations must hold between the fields:
+ * <ul>
+ * <li>{@link width} &gt;= 0 width is non-negative
+ * <li>{@link page} &gt;= 0 page is non-negative
+ * <li>{@link position} &gt;= 0
+ * <li>{@link position} + {@link page} &lt;= {@link width}
+ * </ul>
+ *
+ */
+public final class ScrollModel extends Model
+{
+   /**
+    * the size of the scrolled object in some object-specific units, &gt;= 0
+    */
+   private int width;
+
+   /**
+    * the size of visible region in object-specific units, page &lt;= width
+    */
+   private int page;
+
+   /**
+    * Current scroll position 0 &lt;= position &lt;= (width - page)
+    */
+   private int position;
+
+   /**
+    * Create a scrolling model in some "no scrolling required" state.
+    * It is assumed the model will be updated to the actual state before
+    * being used.
+    */
+   public ScrollModel()
+   {
+      this(0, 0, 0);
+   }
+
+   /**
+    * Create a scrolling model.
+    * 
+    * @param width the width value
+    * @param page the page value
+    * @param position the position.
+    */
+   public ScrollModel(final int width, final int page, final int position)
+   {
+      assert width >= 0;
+      assert page >= 0;
+      assert 0 <= position && position <= (width - page);
+
+      this.width = width;
+      this.page = page;
+      this.position = position;
+   }
+
+   /**
+    * Get the scroll model width.
+    * 
+    * @return see above.
+    */
+   public int getWidth()
+   {
+      return width;
+   }
+
+   /**
+    * Get the scroll model page value.
+    * 
+    * @return see above.
+    */
+   public int getPage()
+   {
+      return page;
+   }
+
+   /**
+    * Set all model data at once.
+    * 
+    * @param width the new width value
+    * @param page the new page value
+    * @param position the new position value
+    * 
+    * @return {@code true} if model was changed as the result of this call.
+    */
+   public boolean set(int width, int page, int position)
+   {
+      if (this.width == width && this.page == page && this.position == position)
+      {
+         return false;
+      }
+
+      assert width >= 0;
+      assert page >= 0;
+      assert 0 <= position;
+      assert position <= (width - page);
+
+      this.width = width;
+      this.page = page;
+      this.position = position;
+
+      changed();
+      return true;
+   }
+
+   /**
+    * Get the scroll model position value.
+    * 
+    * @return see above
+    */
+   public int getPosition()
+   {
+      return position;
+   }
+
+   /**
+    * Get the sum of the position and the page.
+    * 
+    * @return see above
+    */
+   public int getLastVisible()
+   {
+      return position + page;
+   }
+
+   /**
+    * Change the model position.
+    * 
+    * @param position the new position value.
+    * 
+    * @return {@code true} if position was changed as the result of this call.
+    */
+   public boolean setPosition(int position)
+   {
+      assert 0 <= position && position <= (width - page);
+      if (this.position == position)
+      {
+         return false;
+      }
+      this.position = position;
+      changed();
+      return true;
+   }
+
+   /**
+    * Test is any scrolling is possible. With no scrolling possible,
+    * attached scrollbar(s) may be hidden.
+    *  
+    * @return see above
+    */
+   public boolean isScrollAvailable()
+   {
+      return width > 1 && page < width;
+   }
+
+   /**
+    * Convenience function to shift the position by the given number.
+    * Assures the resulting position is valid, i.e. in the [0, width - page] range.
+    *  
+    * @param value any increment value, may be negative.
+    */
+   public boolean increment(int value)
+   {
+      return setPosition(Math.min(width - page, Math.max(0, position + value)));
+   }
+
+   /**
+    * Reset all fields to initial state without sending notifications.
+    */
+   public void reset()
+   {
+      position = 0;
+      page = 0;
+      width = 0;
+   }
+}

=== added file 'src/com/goldencode/p2j/ui/client/widget/AbstractScrollBar.java'
--- src/com/goldencode/p2j/ui/client/widget/AbstractScrollBar.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/widget/AbstractScrollBar.java	2021-06-09 17:16:17 +0000
@@ -0,0 +1,255 @@
+package com.goldencode.p2j.ui.client.widget;
+
+import java.awt.event.*;
+
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.gui.*;
+import com.goldencode.p2j.ui.client.gui.driver.*;
+import com.goldencode.p2j.ui.client.gui.theme.*;
+import com.goldencode.p2j.ui.client.model.*;
+
+abstract class AbstractScrollBar
+extends GenericWidget
+implements IModelChangeListener
+{
+
+   /**
+    * Enumerate all possible mouse positions in the widget area.
+    */
+   protected enum Part
+   {
+      /** The area between the left (upper) button and the thumb */
+      LEFT_AREA,
+
+      /** The left (upper) button */
+      LEFT_BUTTON,
+
+      /** None of the above */
+      NONE,
+
+      /** The area between the right (lower) button and the thumb */
+      RIGHT_AREA,
+
+      /** The right (lower) button */
+      RIGHT_BUTTON,
+
+      /** The thumb */
+      THUMB
+
+   }
+
+   private static final int[] MOUSE_ACTIONS = new int[] { MouseEvent.MOUSE_ENTERED,
+            MouseEvent.MOUSE_EXITED, MouseEvent.MOUSE_MOVED, MouseEvent.MOUSE_DRAGGED,
+            MouseEvent.MOUSE_WHEEL };
+
+   @Override
+   public void destroy()
+   {
+      model.removeListener(this);
+      super.destroy();
+   }
+
+   @Override
+   public void mouseWheelMoved(/* @Nullable */ MouseWheelEvent e)
+   {
+      assert e != null;
+      model.increment(e.getWheelRotation());
+   }
+
+   /**
+    * Find the widget positioned just below the specified mouse position (in physical units).
+    * Since this is the only widget, always return {@code this}.
+    * 
+    * @param    p
+    *           The mouse physical location.
+    * 
+    * @return   A widget over which the mouse is positioned or <code>null</code> if none found.
+    */
+   @Override
+   public Widget<GuiOutputManager> findMouseSource(/* @Nullable */ NativePoint p)
+   {
+      return this;
+   }
+
+   public AbstractScrollBar(ScrollModel model)
+   {
+      this.model = model;
+      model.addListener(this);
+   }
+
+   protected ScrollModel model;
+
+   /** The part the mouse was last time hovered over. */
+   protected Part lastHoverPart = Part.NONE;
+   
+   /** The part the mouse was last time pressed. */
+   protected Part lastPressedPart = Part.NONE;
+   
+   /**
+    * If not {@code null}, the bounding rectangle of currently highlighted part,
+    * this rectangle must be invalidated when highlighted part or thumb position changes.
+    */
+   /* @Nullable */
+   protected NativeRectangle highLightedRect;
+
+   /**
+    * Last pressed mouse position along the scrolling direction.
+    * Used to calculate the drag amount.
+    */
+   protected int lastMousePos;
+
+   /**
+    * Last pressed mouse model position. Used to calculate drag amount.
+    */
+   protected int lastModelPos;
+
+   @Override
+   public void draw()
+   {
+      if (!isVisible())
+      {
+         return;
+      }
+
+      // get location and size
+      NativePoint p = physicalLocation();
+      NativeDimension d = physicalDimension();
+      NativeRectangle clip = clipRectangle(p, d);
+
+      GuiDriver<?, ?> gd = (GuiDriver<?, ?>) OutputManager.getDriver();
+      GuiColorResolver gc = new GuiColorResolver(gd, config(), SysColor.COLOR_SCROLLBAR,
+               SysColor.COLOR_WINDOWTEXT);
+      gc.thumbColor = gd.getSysColor(SysColor.COLOR_3DFACE);
+      gc.colors();
+
+      gd.draw(getId(), p, clip, () -> doDraw(gd, gc));
+   }
+
+   /**
+    * Draw widget using the prepared driver and color resolver.
+    *
+    * @param gd the driver
+    * @param gc the color resolver.
+    */
+   protected abstract void doDraw(GuiDriver<?, ?> gd, GuiColorResolver gc);
+
+   /**
+    * Get the scrollbar minimum length along the scrolling direction.
+    * 
+    * @return see above
+    */
+   protected static final int minLength()
+   {
+      Theme theme = ThemeManager.getCurrentTheme();
+      return 2 * theme.getScrollBarButtonHeight() + theme.getScrollBarThumbMinSize();
+   }
+
+   /**
+    * Get the scrollbar minimum height.
+    * 
+    * @return see above
+    */
+   protected static final int minWidth()
+   {
+      return ThemeManager.getCurrentTheme().getScrollBarThumbWidth();
+   }
+
+   @Override
+   public void modelChanged(Model m)
+   {
+      repaint();
+   }
+
+   @Override
+   protected int[] mouseActions()
+   {
+      return MOUSE_ACTIONS;
+   }
+
+   @Override
+   public void mouseEntered(/* @Nullable */ MouseEvent e)
+   {
+      assert e != null;
+      updatePart(e);
+   }
+
+   @Override
+   public void mouseExited(/* @Nullable */ MouseEvent e)
+   {
+      assert e != null;
+      updatePart(e);
+   }
+
+   @Override
+   public void mouseMoved(/* @Nullable */ MouseEvent e)
+   {
+      assert e != null;
+      updatePart(e);
+   }
+
+   @Override
+   public void mouseReleased(/* @Nullable */ MouseEvent e)
+   {
+      assert e != null;
+      updateMouseHitInfo(e.getX(), e.getY());
+      Part lpp = lastPressedPart;
+      if (lpp == Part.NONE)
+      {
+         return;
+      }
+
+      lastPressedPart = Part.NONE;
+
+      if (lastHoverPart == lpp)
+      {
+         switch (lpp)
+         {
+            case LEFT_BUTTON:
+               model.increment(-1);
+               break;
+            case RIGHT_BUTTON:
+               model.increment(1);
+               break;
+            case LEFT_AREA:
+               model.increment(-model.getPage());
+               break;
+            case RIGHT_AREA:
+               model.increment(model.getPage());
+               break;
+            default:
+               break;
+         }
+      }
+      
+      repaint();
+   }
+
+   protected abstract void updateMouseHitInfo(int x, int y);
+
+   /**
+    * Repaint parts according to their highlight and pressed status when mouse position changes.
+    * 
+    * @param e the mouse event with the mouse position.
+    */
+   private void updatePart(MouseEvent e)
+   {
+      NativeRectangle prevRect = highLightedRect;
+      Part prevPart = lastHoverPart;
+      updateMouseHitInfo(e.getX(), e.getY());
+      if (prevPart != lastHoverPart)
+      {
+         if (prevRect != null)
+         {
+            repaint(prevRect);
+         }
+
+         if (highLightedRect != null)
+         {
+            repaint(highLightedRect);
+         }
+         
+         repaint();
+      }
+   }
+
+}

=== added file 'src/com/goldencode/p2j/ui/client/widget/ArrowsWidget.java'
--- src/com/goldencode/p2j/ui/client/widget/ArrowsWidget.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/widget/ArrowsWidget.java	2021-06-09 19:04:18 +0000
@@ -0,0 +1,107 @@
+package com.goldencode.p2j.ui.client.widget;
+
+import com.goldencode.p2j.ui.*;
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.gui.driver.*;
+
+/**
+ * The {@link ArrowsWidget} widget is used to visually track the arrows when
+ * dragging a column header.
+ * 
+ * An instance of this widget is assumed to be created when dragging starts and destroyed
+ * when dragging ends.
+ * 
+ */
+public final class ArrowsWidget
+extends LightweightWidget
+{
+   /**
+    * Arrow width
+    */
+   final static int ARROWS_WIDTH = 11;
+
+   /**
+    * Arrow height
+    */
+   final static int ARROWS_HEIGHT = 9;
+
+   /**
+    * The vertical distance between the arrows.
+    */
+   private int verticalGap;
+
+   /**
+    * The color to fill the arrows
+    */
+   private ColorRgb fillColor;
+
+   /**
+    * Default constructor.
+    * 
+    */
+   public ArrowsWidget(final int verticalGap, final ColorRgb fillColor)
+   {
+      this.verticalGap = verticalGap;
+      this.fillColor = fillColor;
+   }
+
+   @Override
+   public void draw()
+   {
+      final NativePoint p = physicalLocation();
+      final int left = p.x;
+      final int top = p.y;
+      final int bottom = top + nativeHeight();
+
+      @SuppressWarnings("null")
+      final GuiDriver<?, ?> gd = (GuiDriver<?, ?>) OutputManager.getDriver();
+
+      polygon(gd, new int[] { left + 5, left, left + 3, left + 3, left + 7, left + 7, left + 10 },
+               new int[] { top + 8, top + 3, top + 3, top, top, top + 3, top + 3 });
+
+      polygon(gd, new int[] { left + 5, left + 10, left + 7, left + 7, left + 3, left + 3, left },
+               new int[] { bottom - 9, bottom - 4, bottom - 4, bottom - 1, bottom - 1, bottom - 4,
+                        bottom - 4 });
+   }
+
+   private final void polygon(GuiDriver<?, ?> gd, final int[] xPoints, final int[] yPoints)
+   {
+      final int nPoints = xPoints.length;
+      assert nPoints > 2;
+      assert nPoints == yPoints.length;
+      gd.setColor(fillColor);
+      gd.fillPolygon(xPoints, yPoints);
+
+      gd.setColor(ColorRgb.BLACK);
+
+      int x = xPoints[0];
+      int y = yPoints[0];
+      for (int i = 1; i < nPoints; i++)
+      {
+         gd.drawLine(x, y, xPoints[i], yPoints[i]);
+         x = xPoints[i];
+         y = yPoints[i];
+      }
+
+      gd.drawLine(x, y, xPoints[0], yPoints[0]);
+   }
+
+   @SuppressWarnings("null")
+   @Override
+   public double height()
+   {
+      return screen().coordinates().heightFromNative(nativeHeight());
+   }
+
+   private final int nativeHeight()
+   {
+      return ARROWS_HEIGHT * 2 + verticalGap;
+   }
+
+   @Override
+   public double width()
+   {
+      return screen().coordinates().widthFromNative(ARROWS_WIDTH);
+   }
+
+}

